#ifndef BOARD_GPIO_H_
#define BOARD_GPIO_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
	
	//BOARD_GPIO_ADV7604_I2S_EN,
	//BOARD_GPIO_AIC3101_I2S_EN,
	//BOARD_GPIO_ANA_EDID_UPDATE,
	BOARD_GPIO_EDID_WP_A,//change to IO expander
	BOARD_GPIO_EDID_WP_D,//change to IO expander
	BOARD_GPIO_HOT_PLUG, //change to IO expander
	BOARD_GPIO_RESET_PCA9539A,
	BOARD_GPIO_PWD_ADV7604,//change to IO expander
	BOARD_GPIO_RESET_AIC3101,
	BOARD_GPIO_RESET_ADV7604,//change to IO expander
	BOARD_GPIO_RESET_GV7601,//change to IO expander
	BOARD_GPIO_HDSD_SET_GV7601,//change to IO expander
	
	BOARD_GPIO_NUM, 
} board_gpio_e;

int board_gpio_init(cxt_mgr_handle_t cxt_mgr);
void board_set_gpio(cxt_mgr_handle_t cxt_mgr, board_gpio_e no, gpio_model_pin_value_t value);
gpio_model_pin_value_t board_get_gpio(cxt_mgr_handle_t cxt_mgr, board_gpio_e no);

#ifdef __cplusplus
}
#endif

#endif /* BOARD_GPIO_H_ */

