#ifndef AIC3101_H_
#define AIC3101_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AIC3101_ID aic3101
#define AIC3101_DRVNAME I2C_MODEL_MODULE_STR(aic3101)

typedef void (*hw_reset_func_t)(void *);

typedef struct {
	hw_reset_func_t hw_reset_func;
} aic3101_cfg_t;

enum aic3101_input {
	AIC3101_COMP,
	AIC3101_CVBS,
	AIC3101_SVIDEO,
	AIC3101_INPUT_NONE,
};

void aic3101_audio_select(handle_t aic3101_handle,int input);

#ifdef __cplusplus
}
#endif

#endif /* AIC3101_H_ */

