//#include "AVStream.h"
#include "cxt_mgr.h"
#include "mem_model.h"
#include "AVerScaleVideo.h"

#ifdef USE_ASM
/*extern "C"*/ void /*_stdcall*/ CopyMemory16Bytes(BYTE* pbSrc, BYTE* pbDest, int iWidth,int iHeight,int stride,int iDestStride);
/*extern "C"*/ void /*_stdcall*/ BicubicYUY2Asm(BYTE* pDst, BYTE* pSrc, BYTE* pSrcRYUV, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
										 DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH,
										 LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearLineYUY2Asm(BYTE* pDst,BYTE* pSrc,BYTE* pSrcYUV,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwSrcW,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearYUY2Asm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);

/*extern "C"*/ void /*_stdcall*/ BiLinearLineRAsm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwSrcW,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearRAsm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);

/*extern "C"*/ void /*_stdcall*/ BiLinearLineGBAsm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwSrcW,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearGBAsm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);


/*extern "C"*/ void /*_stdcall*/ BicubicRAsm(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH,
	LONG lSrcStride,LONG lDstStride);

/*extern "C"*/ void /*_stdcall*/ BicubicGBAsm(BYTE* pDst, BYTE* pSrc, BYTE* pSrcRYUV, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH,
	LONG lSrcStride,LONG lDstStride);

/*extern "C"*/ void /*_stdcall*/ BicubicRGB24Asm(BYTE* pDst, BYTE* pSrc, BYTE* pSrcRGB, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
										DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH,
										LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearLineRGB24Asm(BYTE* pDst,BYTE* pSrc,BYTE* pSrcRGB,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwSrcW,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
/*extern "C"*/ void /*_stdcall*/ BiLinearRGB24Asm(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);

#else
void /*_stdcall*/ BiLinearLineYUY2_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BiLinearYUY2_C(BYTE* pDst, BYTE* pSrc, DWORD* pdwPosX,DWORD* pdwPosY, WORD* pwWeight, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BicubicYUY2_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
							DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BiLinearLineRGB24_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BiLinearRGB24_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BicubicRGB24_C(BYTE* pDst, BYTE* pSrc,WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
						 DWORD* pdwPosX, DWORD* pdwPosY,DWORD dwDstW, DWORD dwDstH, LONG lSrcStride,LONG lDstStride);
void  /*_stdcall*/ CopyMemory_C(BYTE* pbSrc, BYTE* pbDest, int iWidth,int iHeight,int iSrcStride,int iDestStride);

void /*_stdcall*/ BiLinearLineR_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BiLinearR_C(BYTE* pDst, BYTE* pSrc, DWORD* pdwPosX,DWORD* pdwPosY, WORD* pwWeight, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BicubicR_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);

void /*_stdcall*/ BiLinearLineGB_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BiLinearGB_C(BYTE* pDst, BYTE* pSrc, DWORD* pdwPosX,DWORD* pdwPosY, WORD* pwWeight, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
void /*_stdcall*/ BicubicGB_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride);
#endif

#define MULTIPLIER 1000


typedef struct _AVM_VSCAL_PARAMS
{
	DWORD dwColorSpace;
	DWORD dwScalingAlg;
	DWORD* pdwPosX;
	DWORD* pdwPosY;
	WORD*  pwWeight;
	LPVOID lpReserve;
}AVM_VSCAL_PARAMS;

//void *AlignedMallocDS(size_t size, size_t align_size) 
//{    
//	char *ptr, *ptr2, *aligned_ptr;
//	int  align_mask = align_size - 1;
//
//	ptr = (char *)ExAllocatePoolWithTag(NonPagedPool, size + align_size + sizeof(int), 'rtp');
//	if (ptr == NULL) 
//		return NULL;
//
//	ptr2 = ptr + sizeof(int);
//	aligned_ptr = ptr2 + (align_size - ((size_t)ptr2 & align_mask));
//
//	ptr2 = aligned_ptr - sizeof(int);
//	*((int *)ptr2) = (int)(aligned_ptr - ptr);
//
//	return aligned_ptr;
//}
//
//void AlignedFreeDS(void *ptr) 
//{    
//	int *ptr2 = (int *)ptr - 1;
//	ptr = (char *)ptr - *ptr2;
//
//	ExFreePool(ptr);
//}



void *AlignedMalloc(size_t size, size_t align_size) 
{    
	char *ptr, *ptr2, *aligned_ptr;
	int  align_mask = (int)(align_size) - 1;

#if 0 //20171215
	ptr = (char *)malloc(size + align_size + sizeof(int));
#else
	ptr = mem_model_new(size + align_size + sizeof(int));
#endif
	if (ptr == NULL) 
		return NULL;

	ptr2 = ptr + sizeof(int);
	aligned_ptr = ptr2 + (align_size - ((size_t)ptr2 & align_mask));

	ptr2 = aligned_ptr - sizeof(int);
	*((int *)ptr2) = (int)(aligned_ptr - ptr);

	return aligned_ptr;
}

void AlignedFree(void *ptr) 
{    
	int *ptr2 = (int *)ptr - 1;
	ptr = (char *)ptr - *ptr2;

#if 0 //20171215
	free(ptr);
#else
	mem_model_delete(ptr);
	ptr = NULL;
#endif
}
BOOL InitBilinearLine(AVM_VSCAL_PARAMS* pScalParams,DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH)
{
	int iPixelStep;
	LONGLONG i;
	pScalParams->pwWeight = (WORD*)AlignedMalloc(dwDstW*4,16);
	if(!pScalParams->pwWeight)
		return AVER_FALSE;

	iPixelStep = pScalParams->dwColorSpace == AVM_CLRSPACE_R? 1: 2;
#ifdef USE_ASM
	if(pScalParams->dwColorSpace == AVM_CLRSPACE_RGB24 || pScalParams->dwColorSpace == AVM_CLRSPACE_YUY2)
	{
		pScalParams->lpReserve = AlignedMalloc(dwSrcW*6,16);
		if(!pScalParams->lpReserve)
			return AVER_FALSE;
	}
	
#else
	if(pScalParams->dwColorSpace == AVM_CLRSPACE_RGB24)
		iPixelStep = 3;
#endif


	for(i=1;i<dwDstW-1;i++)
	{
		LONGLONG nPos=((i*(dwSrcW - 1)) << 14)/(dwDstW-1);
		pScalParams->pdwPosX[i]= (DWORD)((nPos>>14)*iPixelStep);

		pScalParams->pwWeight[i*2+1] = (WORD)(nPos & 0x3FFF);
		pScalParams->pwWeight[i*2] = 0x4000 - pScalParams->pwWeight[i*2+1];

	}

	pScalParams->pdwPosX[0] = 0;
	pScalParams->pwWeight[0] = 1<<14;
	pScalParams->pwWeight[1] = 0;

	pScalParams->pdwPosX[dwDstW-1] = (dwSrcW-2)*iPixelStep;
	pScalParams->pwWeight[dwDstW*2 -2] = 0;
	pScalParams->pwWeight[dwDstW*2 -1] = 1<<14;

	return AVER_TRUE;

}
BOOL InitBilinear(AVM_VSCAL_PARAMS* pScalParams,DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH)
{
	int iPixelStep;
	DWORD* pdwPosX;
	DWORD* pdwPosY;
	WORD* pwWeight;
	long    nposx,nposy;
	LONGLONG nCoffX, nCoffY;
	DWORD x, y, i;
	pScalParams->pwWeight = (WORD*)AlignedMalloc(dwDstW*dwDstH*8, 16);
	if(!pScalParams->pwWeight)
		return AVER_FALSE;

	iPixelStep = 2;
	if(pScalParams->dwColorSpace == AVM_CLRSPACE_RGB24)
		iPixelStep = 3;
	else if(pScalParams->dwColorSpace == AVM_CLRSPACE_R)
		iPixelStep = 1;


	pdwPosX = pScalParams->pdwPosX;
	pdwPosY = pScalParams->pdwPosY;
	pwWeight = pScalParams->pwWeight;

	for(y = 0 ; y < dwDstH; y++)
	{
		nposy= (LONG)((LONGLONG)y*((dwSrcH - 1) << 16)/(dwDstH-1));
		nCoffY = (nposy&0xFFFF);
		pdwPosY[y]= nposy>>16;	
		if(y == dwDstH -1)
		{
			pdwPosY[y] = dwSrcH -2;
			nCoffY = 256;
		}
		for(x = 0; x < dwDstW ; x++)
		{
			nposx=(LONG)((LONGLONG)x* ((dwSrcW - 1) << 16)/(dwDstW-1));
			nCoffX = (nposx&0xFFFF);
			if(x == dwDstW -1)
			{
				nCoffX = 256;
			}
			pwWeight[y*dwDstW*4 + x*4 + 3] = (WORD)((nCoffX * nCoffY)>> 24);
			pwWeight[y*dwDstW*4 + x*4 + 2] = (WORD)(((0x10000 - nCoffX) * nCoffY)>>24);
			pwWeight[y*dwDstW*4 + x*4 + 1] = (WORD)((nCoffX * (0x10000 - nCoffY))>>24);
			pwWeight[y*dwDstW*4 + x*4    ] = (WORD)(256 - pwWeight[y*dwDstW*4 + x*4 + 3] -
				pwWeight[y*dwDstW*4 + x*4 + 2] - pwWeight[y*dwDstW*4 + x*4 + 1]);//(WORD)(((0x10000 - nCoffX) * (0x10000 -nCoffY)+ (1<<23))>>24);
		}
	}

	for(i=0;i<dwDstW;i++)
	{
		nposx= (LONG)((LONGLONG)i* ((dwSrcW - 1) << 16)/(dwDstW-1));
		pdwPosX[i] = (nposx>>16)*iPixelStep;
	}
	pdwPosX[dwDstW-1] = (dwSrcW - 2)*iPixelStep;

	return AVER_TRUE;

}
BOOL InitBicubic(AVM_VSCAL_PARAMS* pScalParams,DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH)
{
	DWORD* pdwPosX;
	DWORD* pdwPosY;
	WORD* pwBicubicWeightX;
	WORD* pwBicubicWeightY;
	DWORD j, i;
	pScalParams->pwWeight = (WORD*)AlignedMalloc((dwDstW+dwDstH)*8, 16);
	if(!pScalParams->pwWeight)
		return AVER_FALSE;

#ifdef USE_ASM
	if(pScalParams->dwColorSpace == AVM_CLRSPACE_RGB24 || pScalParams->dwColorSpace == AVM_CLRSPACE_YUY2
		||pScalParams->dwColorSpace == AVM_CLRSPACE_GB)
	{
		pScalParams->lpReserve = AlignedMalloc(dwSrcW*dwSrcH*3, 16);
	    if(!pScalParams->lpReserve)
		   return AVER_FALSE;
	}
#endif


	pdwPosX = pScalParams->pdwPosX;
	pdwPosY = pScalParams->pdwPosY;
	pwBicubicWeightX = pScalParams->pwWeight;
	pwBicubicWeightY = pScalParams->pwWeight + dwDstW*4;


	for(j=0;j<dwDstH;j++)
	{
		LONGLONG fPos = ((j*(dwSrcH - 3)<<10) + dwDstH/2)/dwDstH + (1<<10);
		WORD wT;
		pdwPosY[j] = (DWORD)fPos>>10;
		fPos -= (pdwPosY[j]<<10);
		pwBicubicWeightY[j*4] = (WORD)(((((fPos*(fPos*(-fPos + (3<<10))-(3<<20))+(1<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightY[j*4 + 1] = (WORD)(((((fPos*fPos*(3*fPos - (6<<10))+(4<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightY[j*4 + 2] = (WORD)(((((fPos*(fPos*(-3*fPos + (3<<10))+(3<<20))+(1<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightY[j*4 + 3] = (WORD)(((((fPos*fPos*fPos)<<8) + (3<<30))>>30)/6);

		wT = pwBicubicWeightY[j*4] + pwBicubicWeightY[j*4 + 1] + pwBicubicWeightY[j*4 + 2] +
			pwBicubicWeightY[j*4 + 3];

		if(wT < 256)
		{
			pwBicubicWeightY[j*4 + 1] += 256 - wT; 
		}
		else
		{
			if(pwBicubicWeightY[j*4 + 1] >= pwBicubicWeightY[j*4 + 2])
				pwBicubicWeightY[j*4 + 1] -= wT - 256;
			else
				pwBicubicWeightY[j*4 + 2] -= wT - 256;

		}

	}

	for(i=0;i<dwDstW;i++)
	{
		LONGLONG fPos = ((i*(dwSrcW - 3)<<10) + dwDstW/2)/dwDstW + (1<<10);
		WORD wT;
		pdwPosX[i] = (DWORD)fPos>>10;
		fPos -= (pdwPosX[i]<<10);
		pwBicubicWeightX[i*4] = (WORD)(((((fPos*(fPos*(-fPos + (3<<10))-(3<<20))+(1<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightX[i*4 + 1] = (WORD)(((((fPos*fPos*(3*fPos - (6<<10))+(4<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightX[i*4 + 2] = (WORD)(((((fPos*(fPos*(-3*fPos + (3<<10))+(3<<20))+(1<<30))<<8)+ (3<<30))>>30)/6);
		pwBicubicWeightX[i*4 + 3] = (WORD)(((((fPos*fPos*fPos)<<8) + (3<<30))>>30)/6);
		wT = pwBicubicWeightX[i*4] + pwBicubicWeightX[i*4 + 1] + pwBicubicWeightX[i*4 + 2] +
			pwBicubicWeightX[i*4 + 3];

		if(wT < 256)
		{
			pwBicubicWeightX[i*4 + 1] += 256 - wT; 
		}
		else
		{
			if(pwBicubicWeightX[i*4 + 1] >= pwBicubicWeightX[i*4 + 2])
				pwBicubicWeightX[i*4 + 1] -= wT - 256;
			else
				pwBicubicWeightX[i*4 + 2] -= wT - 256;

		}
	}
	return AVER_TRUE; //20171215
}

//Added by Jeff_20180827+
BOOL IsScalingSupported(DWORD dwColorSpace)
{
	switch (dwColorSpace)
	{
	case AVM_CLRSPACE_YUY2:
	case AVM_CLRSPACE_RGB24:
	case AVM_CLRSPACE_YV12:
	case AVM_CLRSPACE_NV12:
		return AVER_TRUE;
	default:
		return AVER_FALSE;
	}
}

DWORD GetStride(DWORD dwWidth, DWORD dwColorSpace)
{
    if (dwColorSpace == AVM_CLRSPACE_RGB24)
    {
        return (dwWidth * 3);
    }
    else if (dwColorSpace == AVM_CLRSPACE_YUY2)
    {
        return (dwWidth * 2);
    }
    else if (dwColorSpace == AVM_CLRSPACE_YV12)
    {
        return dwWidth;
    }
    else if (dwColorSpace == AVM_CLRSPACE_NV12)
    {
        return dwWidth;
    }
    else if (dwColorSpace == AVM_CLRSPACE_V210)
    {
        return (((dwWidth + 47) / 48) * 48) * 8 / 3;
    }

    return dwWidth;
}

BOOL AVerDoScale(BYTE** ppInitData, BYTE* pSrc, BYTE* pDst, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH, DWORD dwColorSpace, DWORD dwScalingAlg /*= AVM_VSCAL_BILINEAR*/)
{
    LONG SrcStride, DestStride = 0;
    if (!pSrc || !pDst)
    {
        return AVER_FALSE;
    }

    if (!ppInitData)
    {
        return AVER_FALSE;
    }

    if (!IsScalingSupported(dwColorSpace))
    {
        return AVER_FALSE;
    }

    SrcStride = GetStride(dwSrcW, dwColorSpace);
    DestStride = GetStride(dwDstW, dwColorSpace);

//    ScaleVideoInit(ppInitData, dwColorSpace, dwScalingAlg, dwSrcW, dwSrcH, dwDstW, dwDstH);
    ScaleVideo(pDst, pSrc, ppInitData, dwSrcW, dwSrcH, dwDstW, dwDstH, SrcStride, DestStride);
//    ScaleVideoUninit(ppInitData);

    return AVER_TRUE;
}

BOOL AVerDoCopy(BYTE* pbSrc, BYTE* pbDest, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH, DWORD dwColorSpace)
{
    int iStride;
    if (!pbSrc || !pbDest)
    {
        return AVER_FALSE;
    }

    if ((dwSrcW != dwDstW) || (dwSrcH != dwDstH))
    {
        return AVER_FALSE;
    }

    iStride = GetStride(dwSrcW, dwColorSpace);
    CopyVideoFrameEx(pbSrc, pbDest, iStride, dwSrcH, iStride, iStride, dwColorSpace);
    
    return AVER_TRUE;
}
//Added by Jeff_20180827-

BOOL ScaleVideoInit(BYTE** ppInitData,DWORD dwColorSpace, DWORD dwScalingAlg, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH)
{
	AVM_VSCAL_PARAMS* pScalParams;
	if(!ppInitData)
		return AVER_FALSE;

#if 0 //20171215
	AVM_VSCAL_PARAMS* pScalParams = new AVM_VSCAL_PARAMS;
#else
	pScalParams = mem_model_new(sizeof(AVM_VSCAL_PARAMS));
#endif
	if(!pScalParams)
		return AVER_FALSE;

	*ppInitData = (BYTE*)pScalParams;
	mem_model_memset(pScalParams, 0, sizeof(AVM_VSCAL_PARAMS));
	pScalParams->dwColorSpace = dwColorSpace;
	pScalParams->dwScalingAlg = dwScalingAlg;
	if(dwColorSpace == AVM_CLRSPACE_NV12 || dwColorSpace == AVM_CLRSPACE_YV12)
	{
		BYTE* ppYInitData = NULL;
		BYTE* ppUVInitData = NULL;
		BOOL br = ScaleVideoInit(&ppYInitData,AVM_CLRSPACE_R,dwScalingAlg,dwSrcW,dwSrcH,dwDstW,dwDstH);
		if(br)
		{
			br = ScaleVideoInit(&ppUVInitData,dwColorSpace == AVM_CLRSPACE_NV12?AVM_CLRSPACE_GB:AVM_CLRSPACE_R,dwScalingAlg,dwSrcW>>1,dwSrcH>>1,dwDstW>>1,dwDstH>>1);
			if(!br)
			{
				ScaleVideoUninit(&ppYInitData);
			}
		}

		if(br)
		{
			BYTE** ppYUVInitData = (BYTE**)AlignedMalloc(32,16);
			ppYUVInitData[0] = ppYInitData;
			ppYUVInitData[1] = ppUVInitData;
			pScalParams->lpReserve = ppYUVInitData;
		}
		return br;
	}

	if(dwColorSpace != AVM_CLRSPACE_RGB24 && dwColorSpace != AVM_CLRSPACE_YUY2 
		&& dwColorSpace != AVM_CLRSPACE_R && dwColorSpace != AVM_CLRSPACE_GB)
		return AVER_FALSE;

	if(dwScalingAlg != AVM_VSCAL_BILINEAR && dwScalingAlg != AVM_VSCAL_BICUBIC)
		return AVER_FALSE;

#if 0 //20171215
	pScalParams->pdwPosX = new DWORD[dwDstW];
#else
	pScalParams->pdwPosX = mem_model_new(sizeof(DWORD) * dwDstW);
#endif
	if(!pScalParams->pdwPosX)
		goto FAIL;
#if 0 //20171215
	pScalParams->pdwPosY = new DWORD[dwDstH];
#else
	pScalParams->pdwPosY =  mem_model_new(sizeof(DWORD) * dwDstH);
#endif
	if(!pScalParams->pdwPosY)
		goto FAIL;

	if(dwDstH == dwSrcH)
	{
		if(!InitBilinearLine(pScalParams, dwSrcW,dwSrcH,dwDstW,dwDstH))
			goto FAIL;

	}
	else if(dwSrcW == dwDstW && dwSrcH ==  dwDstH*2)
	{
		pScalParams->pwWeight = NULL;
		pScalParams->lpReserve = NULL;
	}
	else
	{
		if(dwScalingAlg == AVM_VSCAL_BILINEAR)
		{
			if(!InitBilinear(pScalParams, dwSrcW,dwSrcH,dwDstW,dwDstH))
				goto FAIL;

		}
		else
		{
			if(!InitBicubic(pScalParams, dwSrcW,dwSrcH,dwDstW,dwDstH))
				goto FAIL;
		}

	}
	
	return AVER_TRUE;

FAIL:
      if(pScalParams->pdwPosX)
#if 0
		  delete[] pScalParams->pdwPosX;
#else
	  {
		  mem_model_delete(pScalParams->pdwPosX);
		  pScalParams->pdwPosX = NULL;
	  }
#endif
	  if(pScalParams->pdwPosY)
#if 0
		  delete[] pScalParams->pdwPosY;
#else
	  {
		  mem_model_delete(pScalParams->pdwPosY);
		  pScalParams->pdwPosY = NULL;
	  }
#endif
	  if(pScalParams->pwWeight)
		  AlignedFree(pScalParams->pwWeight);
	  if(pScalParams->lpReserve)
		  AlignedFree(pScalParams->lpReserve);

#if 0
	  delete pScalParams;
#else
		  mem_model_delete(pScalParams);
#endif
	  *ppInitData = NULL;

    
	
	return AVER_FALSE;



}
BOOL ScaleVideoUninit(BYTE** ppInitData)
{
	AVM_VSCAL_PARAMS* pScalParams;
	if(!ppInitData || !*ppInitData)
		return AVER_FALSE;

	pScalParams = (AVM_VSCAL_PARAMS*)(*ppInitData);

	if(pScalParams->dwColorSpace == AVM_CLRSPACE_NV12 || pScalParams->dwColorSpace == AVM_CLRSPACE_YV12)
	{
		BYTE** ppYUVInitData = (BYTE**)pScalParams->lpReserve;
		ScaleVideoUninit(&(ppYUVInitData[0]));
		ScaleVideoUninit(&(ppYUVInitData[1]));
	}
	if(pScalParams->pdwPosX)
#if 0
		delete[] pScalParams->pdwPosX;
#else
	{
		mem_model_delete(pScalParams->pdwPosX);
		pScalParams->pdwPosX = NULL;
	}
#endif
	if(pScalParams->pdwPosY)
#if 0
		delete[] pScalParams->pdwPosY;
#else
	{
		mem_model_delete(pScalParams->pdwPosY);
		pScalParams->pdwPosY = NULL;
	}
#endif
	if(pScalParams->pwWeight)
		AlignedFree(pScalParams->pwWeight);
	if(pScalParams->lpReserve)
		AlignedFree(pScalParams->lpReserve);

#if 0
	delete pScalParams;
#else
	mem_model_delete(pScalParams);
#endif
	*ppInitData = NULL;

	return AVER_TRUE;
}
void /*_stdcall*/ BiLinearR_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
	DWORD dwPosX;
	BYTE* pSrcLineUp,*pSrcLineDown;
	BYTE* pDstLine = pDst;
	WORD* pwWeightLine = pwWeight;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLineUp = pSrc + pdwPosY[y]*lSrcStride;
		pSrcLineDown = pSrcLineUp + lSrcStride;
		pDstLine = pDst + y*lDstStride;
		pwWeightLine = pwWeight + y*dwDstW*4;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+1])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+1])*pwWeightLine[3]+ 128)>>8);

			pwWeightLine += 4;
		}
	}

}
void /*_stdcall*/ BiLinearGB_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{

	DWORD dwPosX;
	BYTE* pSrcLineUp,*pSrcLineDown;
	BYTE* pDstLine = pDst;
	WORD* pwWeightLine = pwWeight;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLineUp = pSrc + pdwPosY[y]*lSrcStride;
		pSrcLineDown = pSrcLineUp + lSrcStride;
		pDstLine = pDst + y*lDstStride;
		pwWeightLine = pwWeight + y*dwDstW*4;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+2])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+2])*pwWeightLine[3]+ 128)>>8);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8);

			pwWeightLine += 4;
		}
	}

}

void /*_stdcall*/ BiLinearYUY2_C(BYTE* pDst, BYTE* pSrc, DWORD* pdwPosX,DWORD* pdwPosY, WORD* pwWeight,DWORD dwDstW, DWORD dwDstH,
						LONG lSrcStride,LONG lDstStride)
{
	int y1,y2,u1, u2,v1,v2;
	DWORD dwPosX;
	BYTE* pSrcLineUp,*pSrcLineDown;
	BYTE* pDstLine = pDst;
	WORD* pwWeightLine = pwWeight;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLineUp = pSrc + pdwPosY[y]*lSrcStride;//pSrc + (pdwPosY[y]>>1)*lSrcStride;
		pSrcLineDown = pSrcLineUp + lSrcStride;//pSrc + ((pdwPosY[y]+1)>>1)*lSrcStride;
		pDstLine = pDst + y*lDstStride;
		pwWeightLine = pwWeight + y*dwDstW*4;
		for(x = 0 ; x < dwDstW; x+=2)
		{
			dwPosX = pdwPosX[x];
			y1 = ((DWORD)(pSrcLineUp[dwPosX]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+2])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+2])*pwWeightLine[3]+ 128)>>8;
			if(dwPosX&2)
			{
				u1 = ((DWORD)(pSrcLineUp[dwPosX-1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX-1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8;

				v1 = ((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+5])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+5])*pwWeightLine[3]+ 128)>>8;

			}
			else
			{
				u1 = ((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+1])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+1])*pwWeightLine[3]+ 128)>>8;
				v1 = ((DWORD)(pSrcLineUp[dwPosX+3]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+3]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8;

			}

			pwWeightLine += 4;

			dwPosX = pdwPosX[x+1];
			y2 = ((DWORD)(pSrcLineUp[dwPosX]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+2])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+2])*pwWeightLine[3]+ 128)>>8;
			if(dwPosX&2)
			{
				u2 = ((DWORD)(pSrcLineUp[dwPosX-1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX-1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8;

				v2 = ((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+5])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+5])*pwWeightLine[3]+ 128)>>8;

			}
			else
			{
				u2 = ((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+1])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+1])*pwWeightLine[3]+ 128)>>8;
				v2 = ((DWORD)(pSrcLineUp[dwPosX+3]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
					(DWORD)(pSrcLineDown[dwPosX+3]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8;

			}

#if 0 //20171215
			pDstLine[0] = y1;
			pDstLine[1] = (u1 + u2 + 1)>>1;
			pDstLine[2] = y2;
			pDstLine[3] = (v1 + v2 + 1)>>1;
#else
			pDstLine[0] = (BYTE) (y1);
			pDstLine[1] = (BYTE) ((u1 + u2 + 1) >> 1);
			pDstLine[2] = (BYTE) (y2);
			pDstLine[3] = ((v1 + v2 + 1)>>1);
#endif


			pDstLine +=4;
			pwWeightLine+=4;

		}
	}

}

void /*_stdcall*/ BiLinearRGB24_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,DWORD* pdwPosY,WORD* pwWeight,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{

	DWORD dwPosX;
	BYTE* pSrcLineUp,*pSrcLineDown;
	BYTE* pDstLine = pDst;
	WORD* pwWeightLine = pwWeight;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLineUp = pSrc + pdwPosY[y]*lSrcStride;
		pSrcLineDown = pSrcLineUp + lSrcStride;
		pDstLine = pDst + y*lDstStride;
		pwWeightLine = pwWeight + y*dwDstW*4;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+3])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+3])*pwWeightLine[3]+ 128)>>8);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX+1]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+4])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX+1]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+4])*pwWeightLine[3]+ 128)>>8);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLineUp[dwPosX+2]) * pwWeightLine[0] + (DWORD)(pSrcLineUp[dwPosX+5])*pwWeightLine[1]+
				(DWORD)(pSrcLineDown[dwPosX+2]) * pwWeightLine[2] + (DWORD)(pSrcLineDown[dwPosX+5])*pwWeightLine[3]+ 128)>>8);


			pwWeightLine += 4;
		}
	}

}

BOOL ScaleVideo(BYTE* pDst, BYTE* pSrc, BYTE** ppInitData, DWORD dwSrcW, DWORD dwSrcH,DWORD dwDstW, DWORD dwDstH,
					LONG lSrcStride,LONG lDstStride)
{
	AVM_VSCAL_PARAMS* pScalParams;
	if(!pDst||!pSrc||!ppInitData||!*ppInitData)
		return AVER_FALSE;

	pScalParams = (AVM_VSCAL_PARAMS*)(*ppInitData);

	if(pScalParams->dwColorSpace == AVM_CLRSPACE_NV12)
	{
		BYTE** ppYUVInitData = (BYTE**)pScalParams->lpReserve;
		
		ScaleVideo(pDst,pSrc,&(ppYUVInitData[0]),dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
		ScaleVideo(pDst+lDstStride*dwDstH,pSrc+lSrcStride*dwSrcH,&(ppYUVInitData[1]),dwSrcW>>1,dwSrcH>>1,dwDstW>>1,dwDstH>>1,lSrcStride,lDstStride);

		return AVER_TRUE;
	}
	else if(pScalParams->dwColorSpace == AVM_CLRSPACE_YV12)
	{
		BYTE** ppYUVInitData = (BYTE**)pScalParams->lpReserve;

		ScaleVideo(pDst,pSrc,&(ppYUVInitData[0]),dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
		ScaleVideo(pDst+lDstStride*dwDstH,pSrc+lSrcStride*dwSrcH,&(ppYUVInitData[1]),dwSrcW>>1,dwSrcH>>1,dwDstW>>1,dwDstH>>1,lSrcStride>>1,lDstStride>>1);
		ScaleVideo(pDst+lDstStride*dwDstH*5/4,pSrc+lSrcStride*dwSrcH*5/4,
			&(ppYUVInitData[1]),dwSrcW>>1,dwSrcH>>1,dwDstW>>1,dwDstH>>1,lSrcStride>>1,lDstStride>>1);

		return AVER_TRUE;
	}

	if(dwDstH == dwSrcH)
	{
		switch(pScalParams ->dwColorSpace)
		{
#ifdef USE_ASM
		case AVM_CLRSPACE_RGB24:
			BiLinearLineRGB24Asm(pDst,pSrc,(BYTE*)(pScalParams->lpReserve),pScalParams->pdwPosX,pScalParams->pwWeight,dwSrcW, dwDstW,dwDstH,lSrcStride,lDstStride);
			break;
		case AVM_CLRSPACE_R:
			BiLinearLineRAsm(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight,dwSrcW, dwDstW,dwDstH,lSrcStride,lDstStride);
			break;
		case AVM_CLRSPACE_GB:
			BiLinearLineGBAsm(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight,dwSrcW, dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
		default:
			BiLinearLineYUY2Asm(pDst,pSrc,(BYTE*)(pScalParams->lpReserve),pScalParams->pdwPosX,pScalParams->pwWeight,dwSrcW, dwDstW,dwDstH,lSrcStride,lDstStride);
#else
		case AVM_CLRSPACE_RGB24:
			BiLinearLineRGB24_C(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight/*,dwSrcW*/, dwDstW,dwDstH,lSrcStride,lDstStride);
			break;
		case AVM_CLRSPACE_R:
			BiLinearLineR_C(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight/*,dwSrcW*/, dwDstW,dwDstH,lSrcStride,lDstStride);
			break;
		case AVM_CLRSPACE_GB:
			BiLinearLineGB_C(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight/*,dwSrcW*/, dwDstW,dwDstH,lSrcStride,lDstStride);
			break;
		default:
			BiLinearLineYUY2_C(pDst,pSrc,pScalParams->pdwPosX,pScalParams->pwWeight, dwDstW,dwDstH,lSrcStride,lDstStride);
#endif
		}

			
	}
	else if(dwSrcW == dwDstW && dwSrcH ==  dwDstH*2)
	{

		DWORD dwLinePixels = dwDstW;
		if(pScalParams->dwColorSpace == AVM_CLRSPACE_GB || pScalParams->dwColorSpace == AVM_CLRSPACE_YUY2)
			dwLinePixels = dwDstW*2;
		else if(pScalParams->dwColorSpace == AVM_CLRSPACE_RGB24)
			dwLinePixels = dwDstW*3;
#ifdef USE_ASM
		CopyMemory16Bytes(pSrc,pDst,dwLinePixels,dwDstH,lSrcStride*2,lDstStride);
#else
		CopyMemory_C(pSrc,pDst,dwLinePixels,dwDstH,lSrcStride*2,lDstStride);
#endif
	}
	else
	{
		if(pScalParams->dwScalingAlg == AVM_VSCAL_BICUBIC)
		{
			switch(pScalParams ->dwColorSpace)
			{
#ifdef USE_ASM
			case AVM_CLRSPACE_RGB24:
				BicubicRGB24Asm(pDst, pSrc, (BYTE*)(pScalParams->lpReserve),pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_R:
				BicubicRAsm(pDst, pSrc, pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_GB:
				BicubicGBAsm(pDst, pSrc, (BYTE*)(pScalParams->lpReserve),pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			default:
				BicubicYUY2Asm(pDst, pSrc, (BYTE*)(pScalParams->lpReserve),pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwSrcW,dwSrcH,dwDstW,dwDstH,lSrcStride,lDstStride);
#else
			case AVM_CLRSPACE_RGB24:
				BicubicRGB24_C(pDst, pSrc, pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_R:
				BicubicR_C(pDst, pSrc, pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_GB:
				BicubicGB_C(pDst, pSrc, pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			default:
				BicubicYUY2_C(pDst, pSrc, pScalParams->pwWeight,pScalParams->pwWeight + dwDstW*4,
					pScalParams->pdwPosX,pScalParams->pdwPosY,dwDstW,dwDstH,lSrcStride,lDstStride);
#endif
			}
		}
		else
		{
			switch(pScalParams ->dwColorSpace)
			{
#ifdef USE_ASM
			case AVM_CLRSPACE_RGB24:
				BiLinearRGB24Asm(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_R:
				BiLinearRAsm(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_GB:
				BiLinearGBAsm(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			default:
				BiLinearYUY2Asm(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
#else
			case AVM_CLRSPACE_RGB24:
				BiLinearRGB24_C(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_R:
				BiLinearR_C(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			case AVM_CLRSPACE_GB:
				BiLinearGB_C(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
				break;
			default:
				BiLinearYUY2_C(pDst, pSrc,pScalParams->pdwPosX,pScalParams->pdwPosY,pScalParams->pwWeight,dwDstW,dwDstH,lSrcStride,lDstStride);
#endif
			}
	   }
	}

	return AVER_TRUE;
}

#ifndef USE_ASM
void /*_stdcall*/ BiLinearLineR_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
	DWORD dwPosX;
	BYTE* pSrcLine = pSrc;
	BYTE* pDstLine = pDst;
	WORD* pwWeightT = pwWeightX;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pwWeightT = pwWeightX;
		pDstLine = pDst + y*lDstStride;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];

			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+1])*pwWeightT[1] + 8192)>>14);

			pwWeightT+=2;

		}
		pSrcLine += lSrcStride;
	}
}
void /*_stdcall*/ BiLinearLineGB_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
	DWORD dwPosX;
	BYTE* pSrcLine = pSrc;
	BYTE* pDstLine = pDst;
	WORD* pwWeightT = pwWeightX;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pwWeightT = pwWeightX;
		pDstLine = pDst + y*lDstStride;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];

			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+2])*pwWeightT[1] + 8192)>>14);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX+1]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+3])*pwWeightT[1] + 8192)>>14);

			pwWeightT+=2;

		}
		pSrcLine += lSrcStride;
	}
}
void /*_stdcall*/ BicubicR_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,
	LONG lSrcStride,LONG lDstStride)
{
#define FAST_BICUBIC_POINT(x1,x2,x3,x4)   \
	(((DWORD)(pSrcLine1[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine1[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine1[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine1[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[0] \
	+ ((DWORD)(pSrcLine2[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine2[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine2[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine2[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[1] \
	+ ((DWORD)(pSrcLine3[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine3[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine3[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine3[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[2] \
	+ ((DWORD)(pSrcLine4[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine4[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine4[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine4[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[3] + 32768)>>16

	BYTE* pDstLine,*pSrcLine1,*pSrcLine2,*pSrcLine3,*pSrcLine4;
	WORD* pwBicubicWeightXT;
	DWORD dwPosX;
	DWORD x=0, y=0;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLine1 = pSrc + lSrcStride*pdwPosY[y] - lSrcStride;
		pSrcLine2 = pSrcLine1 + lSrcStride;
		pSrcLine3 = pSrcLine2 + lSrcStride;
		pSrcLine4 = pSrcLine3 + lSrcStride;
		pDstLine = pDst + lDstStride*y;
		pwBicubicWeightXT = pwBicubicWeightX;

		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-1,dwPosX,dwPosX+1,dwPosX+2));
			pwBicubicWeightXT+=4;

		}
		pwBicubicWeightY += 4;
	}

}
void /*_stdcall*/ BicubicGB_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
	DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,
	LONG lSrcStride,LONG lDstStride)
{
#undef FAST_BICUBIC_POINT
#define FAST_BICUBIC_POINT(x1,x2,x3,x4)   \
	(((DWORD)(pSrcLine1[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine1[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine1[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine1[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[0] \
	+ ((DWORD)(pSrcLine2[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine2[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine2[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine2[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[1] \
	+ ((DWORD)(pSrcLine3[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine3[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine3[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine3[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[2] \
	+ ((DWORD)(pSrcLine4[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine4[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine4[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine4[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[3] + 32768)>>16

	BYTE* pDstLine,*pSrcLine1,*pSrcLine2,*pSrcLine3,*pSrcLine4;
	WORD* pwBicubicWeightXT;
	DWORD dwPosX;
	DWORD x = 0, y = 0;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLine1 = pSrc + lSrcStride*pdwPosY[y] - lSrcStride;
		pSrcLine2 = pSrcLine1 + lSrcStride;
		pSrcLine3 = pSrcLine2 + lSrcStride;
		pSrcLine4 = pSrcLine3 + lSrcStride;
		pDstLine = pDst + lDstStride*y;
		pwBicubicWeightXT = pwBicubicWeightX;

		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x]*2;
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-2,dwPosX,dwPosX+2,dwPosX+4));
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-1,dwPosX+1,dwPosX+3,dwPosX+5));
			pwBicubicWeightXT+=4;


		}
		pwBicubicWeightY += 4;
	}

}
void /*_stdcall*/ BiLinearLineYUY2_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
	int y1,y2,u1, u2,v1,v2;
	DWORD dwPosX;
	BYTE* pSrcLine = pSrc;
	BYTE* pDstLine = pDst;
	WORD* pwWeightT = pwWeightX;
	DWORD x = 0, y = 0;
	for(y = 0 ; y < dwDstH; y++)
	{
		pwWeightT = pwWeightX;
		pDstLine = pDst + y*lDstStride;
		for(x = 0 ; x < dwDstW; x+=2)
		{
			dwPosX = pdwPosX[x];
			y1 = ((DWORD)(pSrcLine[dwPosX]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+2])*pwWeightT[1] + 8192)>>14;
			if(dwPosX&2)
			{
				u1 = ((DWORD)(pSrcLine[dwPosX-1]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+3])*pwWeightT[1] + 8192)>>14;
				v1 = ((DWORD)(pSrcLine[dwPosX+1]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+5])*pwWeightT[1] + 8192)>>14;

			}
			else
			{
				u1 = pSrcLine[dwPosX+1];
				v1 = pSrcLine[dwPosX+3];

			}

			dwPosX = pdwPosX[x+1];
			y2 = ((DWORD)(pSrcLine[dwPosX]) * pwWeightT[2] + (DWORD)(pSrcLine[dwPosX+2])*pwWeightT[3] + 8192)>>14;
			if(dwPosX&2)
			{
				u2 = ((DWORD)(pSrcLine[dwPosX-1]) * pwWeightT[2] + (DWORD)(pSrcLine[dwPosX+3])*pwWeightT[3] + 8192)>>14;
				v2 = ((DWORD)(pSrcLine[dwPosX+1]) * pwWeightT[2] + (DWORD)(pSrcLine[dwPosX+5])*pwWeightT[3] + 8192)>>14;

			}
			else
			{
				u2 = pSrcLine[dwPosX+1];
				v2 = pSrcLine[dwPosX+3];

			}
			pDstLine[0] = (BYTE)(y1);
			pDstLine[1] = (BYTE)((u1 + u2 + 1)>>1);
			pDstLine[2] = (BYTE)(y2);
			pDstLine[3] = (BYTE)((v1 + v2 + 1)>>1);


			pDstLine +=4;
			pwWeightT+=4;

		}
		pSrcLine += lSrcStride;
	}
}
void /*_stdcall*/ BicubicYUY2_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
						DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
#undef FAST_BICUBIC_POINT
#define FAST_BICUBIC_POINT(x1,x2,x3,x4)   \
	(((DWORD)(pSrcLine1[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine1[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine1[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine1[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[0] \
	+ ((DWORD)(pSrcLine2[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine2[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine2[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine2[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[1] \
	+ ((DWORD)(pSrcLine3[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine3[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine3[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine3[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[2] \
	+ ((DWORD)(pSrcLine4[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine4[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine4[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine4[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[3] + 32768)>>16

	int y1,y2,u1,u2,v1,v2;
	BYTE* pDstLine,*pSrcLine1,*pSrcLine2,*pSrcLine3,*pSrcLine4;
	WORD* pwBicubicWeightXT;
	DWORD dwPosX;
	DWORD x = 0, y = 0;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLine1 = pSrc + lSrcStride*pdwPosY[y] - lSrcStride;
		pSrcLine2 = pSrcLine1 + lSrcStride;
		pSrcLine3 = pSrcLine2 + lSrcStride;
		pSrcLine4 = pSrcLine3 + lSrcStride;
		pDstLine = pDst + lDstStride*y;
		pwBicubicWeightXT = pwBicubicWeightX;

		for(x = 0 ; x < dwDstW; x+=2)
		{
			dwPosX = pdwPosX[x]<<1;
			y1 =  FAST_BICUBIC_POINT(dwPosX-2,dwPosX,dwPosX+2,dwPosX+4); 
			if(dwPosX&2)
			{
				u1 = FAST_BICUBIC_POINT(dwPosX-1,dwPosX-1,dwPosX+3,dwPosX+3); 

				v1 =  FAST_BICUBIC_POINT(dwPosX+1,dwPosX+1,dwPosX+5,dwPosX+5);

			}
			else
			{
				u1 = FAST_BICUBIC_POINT(dwPosX-3,dwPosX+1,dwPosX+1,dwPosX+5); 
				v1 =  FAST_BICUBIC_POINT(dwPosX-1,dwPosX+3,dwPosX+3,dwPosX+7);
			}

			dwPosX = pdwPosX[x+1]<<1;
			pwBicubicWeightXT+=4;

			y2 =  FAST_BICUBIC_POINT(dwPosX-2,dwPosX,dwPosX+2,dwPosX+4); 
			if(dwPosX&2)
			{
				u2 = FAST_BICUBIC_POINT(dwPosX-1,dwPosX-1,dwPosX+3,dwPosX+3); 
				v2 =  FAST_BICUBIC_POINT(dwPosX+1,dwPosX+1,dwPosX+5,dwPosX+5);
			}
			else
			{
				u2 = FAST_BICUBIC_POINT(dwPosX-3,dwPosX+1,dwPosX+1,dwPosX+5); 
				v2 =  FAST_BICUBIC_POINT(dwPosX-1,dwPosX+3,dwPosX+3,dwPosX+7);
			}

			pDstLine[0] = (BYTE)(y1);
			pDstLine[1] = (BYTE)((u1 + u2 + 1)>>1);
			pDstLine[2] = (BYTE)(y2);
			pDstLine[3] = (BYTE)((v1 + v2 + 1)>>1);


			pDstLine +=4;
			pwBicubicWeightXT+=4;


		}
		pwBicubicWeightY += 4;
	}

}
void /*_stdcall*/ BiLinearLineRGB24_C(BYTE* pDst,BYTE* pSrc,DWORD* pdwPosX,WORD* pwWeightX,DWORD dwDstW,DWORD dwDstH,LONG lSrcStride,LONG lDstStride)
{
	DWORD dwPosX;
	BYTE* pSrcLine = pSrc;
	BYTE* pDstLine = pDst;
	WORD* pwWeightT = pwWeightX;
	DWORD x = 0, y = 0;
	for(y = 0 ; y < dwDstH; y++)
	{
		pwWeightT = pwWeightX;
		pDstLine = pDst + y*lDstStride;
		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x];

			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+3])*pwWeightT[1] + 8192)>>14);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX+1]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+4])*pwWeightT[1] + 8192)>>14);
			*pDstLine++ = (BYTE)(((DWORD)(pSrcLine[dwPosX+2]) * pwWeightT[0] + (DWORD)(pSrcLine[dwPosX+5])*pwWeightT[1] + 8192)>>14);

			pwWeightT+=2;

		}
		pSrcLine += lSrcStride;
	}
}
void /*_stdcall*/ BicubicRGB24_C(BYTE* pDst, BYTE* pSrc, WORD* pwBicubicWeightX, WORD* pwBicubicWeightY,
						DWORD* pdwPosX, DWORD* pdwPosY, DWORD dwDstW, DWORD dwDstH,
						LONG lSrcStride,LONG lDstStride)
{
#define FAST_BICUBIC_POINT(x1,x2,x3,x4)   \
	(((DWORD)(pSrcLine1[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine1[(x2)])*pwBicubicWeightXT[1] +\
	(DWORD)(pSrcLine1[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine1[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[0] \
	+ ((DWORD)(pSrcLine2[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine2[(x2)])*pwBicubicWeightXT[1] +\
		(DWORD)(pSrcLine2[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine2[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[1] \
	+ ((DWORD)(pSrcLine3[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine3[(x2)])*pwBicubicWeightXT[1] +\
		(DWORD)(pSrcLine3[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine3[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[2] \
	+ ((DWORD)(pSrcLine4[(x1)])*pwBicubicWeightXT[0] + (DWORD)(pSrcLine4[(x2)])*pwBicubicWeightXT[1] +\
		(DWORD)(pSrcLine4[(x3)])*pwBicubicWeightXT[2] + (DWORD)(pSrcLine4[(x4)])*pwBicubicWeightXT[3]) * pwBicubicWeightY[3] + 32768)>>16
	
	BYTE* pDstLine,*pSrcLine1,*pSrcLine2,*pSrcLine3,*pSrcLine4;
	WORD* pwBicubicWeightXT;
	DWORD dwPosX;
	DWORD x, y;
	for(y = 0 ; y < dwDstH; y++)
	{
		pSrcLine1 = pSrc + lSrcStride*pdwPosY[y] - lSrcStride;
		pSrcLine2 = pSrcLine1 + lSrcStride;
		pSrcLine3 = pSrcLine2 + lSrcStride;
		pSrcLine4 = pSrcLine3 + lSrcStride;
		pDstLine = pDst + lDstStride*y;
		pwBicubicWeightXT = pwBicubicWeightX;

		for(x = 0 ; x < dwDstW; x++)
		{
			dwPosX = pdwPosX[x]*3;
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-3,dwPosX,dwPosX+3,dwPosX+6));
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-2,dwPosX+1,dwPosX+4,dwPosX+7));
			*pDstLine++ = (BYTE)(FAST_BICUBIC_POINT(dwPosX-1,dwPosX+2,dwPosX+5,dwPosX+8));
			pwBicubicWeightXT+=4;


		}
		pwBicubicWeightY += 4;
	}

}
void  /*_stdcall*/ CopyMemory_C(BYTE* pSrc, BYTE* pDst, int iWidth,int iHeight,int iSrcStride,int iDestStride)
{
	LONGLONG* pllSrcLine, * pllDstLine;
	int iWidthT = iWidth&~7;
	int x, y;
	for(y = 0 ; y < iHeight; y++ )
	{
		pllSrcLine = (LONGLONG*)(pSrc + iSrcStride*y);
		pllDstLine = (LONGLONG*)(pDst + iDestStride*y);
		for(x = 0; x < iWidthT; x+=8)
		{
			*pllDstLine = *pllSrcLine;
			pllDstLine++;
			pllSrcLine++;

		}
	}


}
#endif
//20171215+
void CopyVideoFrame(BYTE* pbDest, BYTE* pbSrc, int BytesPerLine, int LinesPerFrame)
{
#ifdef USE_ASM
    CopyMemory16Bytes(pbSrc, pbDest, BytesPerLine, LinesPerFrame, BytesPerLine, BytesPerLine);
#endif // USE_ASM
}
//20171215-

void CopyVideoFrameEx(BYTE* pbSrc, BYTE* pbDest, int iWidth, int iHeight, int iSrcStride, int iDestStride, DWORD dwColorSpace)
{
#ifdef USE_ASM
	if (dwColorSpace == AVM_CLRSPACE_NV12)
	{
		int offset = 0;
		CopyMemory16Bytes(pbSrc, pbDest, iWidth, iHeight, iSrcStride, iDestStride);
		offset = iSrcStride * iHeight;
		CopyMemory16Bytes((pbSrc + offset), (pbDest + offset), iWidth, (iHeight / 2), iSrcStride, iDestStride);
	}
	else if (dwColorSpace == AVM_CLRSPACE_YV12)
	{
		DWORD offset = 0;
		CopyMemory16Bytes(pbSrc, pbDest, iWidth, iHeight, iSrcStride, iDestStride);
		offset = iSrcStride * iHeight;
		CopyMemory16Bytes((pbSrc + offset), (pbDest + offset), iWidth, iHeight / 4, iSrcStride, iDestStride);
		offset += iSrcStride * (iHeight / 4);
		CopyMemory16Bytes((pbSrc + offset), (pbDest + offset), iWidth, iHeight / 4, iSrcStride, iDestStride);
	}
	else if (dwColorSpace == AVM_CLRSPACE_RGB24)
	{
		CopyMemory16Bytes(pbSrc, pbDest, iWidth, iHeight, iSrcStride, iDestStride);
	}
	else if (dwColorSpace == AVM_CLRSPACE_YUY2)
	{
		CopyMemory16Bytes(pbSrc, pbDest, iWidth, iHeight, iSrcStride, iDestStride);
	}
	else
	{
		CopyMemory16Bytes(pbSrc, pbDest, iWidth, iHeight, iSrcStride, iDestStride);
	}
#endif // USE_ASM
}

//Added by Jeff_20180802+
//DWORD TranslateFourccToAvmClrSpace(DWORD Compression, DWORD SubFourcc)
//{
//	DWORD dwColorSpace = 0;
//
//	switch (Compression)
//	{
//	case FOURCC_YUYV:
//	case FOURCC_YUY2:
//		dwColorSpace = AVM_CLRSPACE_YUY2;
//		break;
//	case FOURCC_YV12:
//		dwColorSpace = AVM_CLRSPACE_YV12;
//		break;
//	case FOURCC_NV12:
//		dwColorSpace = AVM_CLRSPACE_NV12;
//		break;
//	case FOURCC_I420:
//		dwColorSpace = AVM_CLRSPACE_I420;
//		break;
//	case FOURCC_YVYU:
//		dwColorSpace = AVM_CLRSPACE_YVYU;
//		break;
//	case FOURCC_UYVY:
//		dwColorSpace = AVM_CLRSPACE_UYVY;
//		break;
//	case FOURCC_V210:
//		dwColorSpace = AVM_CLRSPACE_V210;
//		break ;
//	case FOURCC_IYU2:
//		dwColorSpace = AVM_CLRSPACE_IYU2;
//		break;
//	case FOURCC_AYUV:
//		dwColorSpace = AVM_CLRSPACE_AYUV;
//		break;
//	case FOURCC_V410:
//		dwColorSpace = AVM_CLRSPACE_V410;
//		break;
//	case FOURCC_Y410:
//		dwColorSpace = AVM_CLRSPACE_Y410;
//		break;
//	case FOURCC_Y210:
//		dwColorSpace = AVM_CLRSPACE_Y210;
//		break;
//
//	case KS_BI_RGB:
//		if (SubFourcc == FOURCC_RGB555)
//			dwColorSpace = AVM_CLRSPACE_RGB555;
//		else if (SubFourcc == FOURCC_RGB565)
//			dwColorSpace = AVM_CLRSPACE_RGB565;
//		else if (SubFourcc == FOURCC_RGB24)
//			dwColorSpace = AVM_CLRSPACE_RGB24;
//		else if (SubFourcc == FOURCC_RGB32)
//			dwColorSpace = AVM_CLRSPACE_RGB32;
//		else if (SubFourcc == FOURCC_ARGB32)
//			dwColorSpace = AVM_CLRSPACE_ARGB32;
//		else if (SubFourcc == FOURCC_XRGB)
//			dwColorSpace = AVM_CLRSPACE_XRGB;
//		else
//			dwColorSpace = AVM_CLRSPACE_RGB24;
//		break;
//	default:
//		break;
//	}
//
//	return dwColorSpace;
//}
//Added by Jeff_20180802-

BOOL AVerVideoProcess(BYTE* pbSrc, BYTE* pbDest, DWORD dwWidth, DWORD dwHeight, DWORD dwColorSpace, DWORD dwFrameExtent, BOOL bInterlace, BOOL bNeedInterlace, BOOL bNeedFlip)
{
	BYTE* pbSrcTemp = 0;
	BYTE* pbDestTemp = 0;
	DWORD dwWidthTemp = 0;
	DWORD dwHeightTemp = 0;
	DWORD dwFrameExtentTemp = 0;
	int iStride = 0;
	int i;

	if (!pbSrc || !pbDest)
	{
		return AVER_FALSE;
	}

	switch (dwColorSpace)
	{
	case AVM_CLRSPACE_YV12:
	case AVM_CLRSPACE_I420:
		if (bInterlace && bNeedInterlace)
		{
			//Modify Y plane.
			pbSrcTemp = pbSrc;
			pbDestTemp = pbDest;
			dwWidthTemp = dwWidth;
			dwHeightTemp = dwHeight;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}

			//Modify V plane for YV12, U plane for I420.
			pbSrcTemp = pbSrc + dwWidth * dwHeight;
			pbDestTemp = pbDest + dwWidth * dwHeight;
			dwWidthTemp = dwWidth / 2;
			dwHeightTemp = dwHeight / 2;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}

			//Modify U plane for YV12, V plane for I420.
			pbSrcTemp = pbSrc + dwWidth * dwHeight + dwWidth / 2 * dwHeight / 2;
			pbDestTemp = pbDest + dwWidth * dwHeight + dwWidth / 2 * dwHeight / 2;
			dwWidthTemp = dwWidth / 2;
			dwHeightTemp = dwHeight / 2;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}

			//Copy the data back to pbSrc.
			CopyVideoFrameEx(pbDest, pbSrc, dwWidth, dwHeight/2*3, dwWidth, dwWidth, 0);
			if (dwWidth % 16 != 0)
			{
				CopyVideoFrameEx(pbDest + dwWidth - 16, pbSrc + dwWidth - 16, 16, dwHeight / 2 * 3, dwWidth, dwWidth, 0);
			}
		}

		break;
	case AVM_CLRSPACE_NV12:
		if (bInterlace && bNeedInterlace)
		{
			//Modify Y plane.
			pbSrcTemp = pbSrc;
			pbDestTemp = pbDest;
			dwWidthTemp = dwWidth;
			dwHeightTemp = dwHeight;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}

			//Copy the data back to pbSrcTemp.
			CopyVideoFrameEx(pbDestTemp, pbSrcTemp, dwWidthTemp, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			if (dwWidthTemp % 16 != 0)
			{
				CopyVideoFrameEx(pbDestTemp + dwWidthTemp - 16, pbSrcTemp + dwWidthTemp - 16, 16, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			}

			//Modify UV plane.
			pbSrcTemp = pbSrc + dwWidth * dwHeight;
			pbDestTemp = pbDest + dwWidth * dwHeight;
			dwWidthTemp = dwWidth;
			dwHeightTemp = dwHeight / 2;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}

			//Copy the data back to pbSrcTemp.
			CopyVideoFrameEx(pbDestTemp, pbSrcTemp, dwWidthTemp, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			if (dwWidthTemp % 16 != 0)
			{
				CopyVideoFrameEx(pbDestTemp + dwWidthTemp - 16, pbSrcTemp + dwWidthTemp - 16, 16, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			}
		}

		break;
	case AVM_CLRSPACE_RGB24:
	case AVM_CLRSPACE_RGB32:

		dwFrameExtentTemp = (dwFrameExtent / (dwWidth * dwHeight)) * (dwWidth * dwHeight);

		if (bInterlace && bNeedInterlace)
		{
			DWORD dwOffset = 0;
			pbSrcTemp = pbSrc;
			pbDestTemp = pbDest;
			dwWidthTemp = dwFrameExtentTemp / dwHeight;
			dwHeightTemp = dwHeight;
			iStride = dwWidthTemp * 2;

			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}
			
			if (bNeedFlip)
			{
				pbSrcTemp = pbSrcTemp + dwFrameExtentTemp - dwWidthTemp;

				for (i = 0; i < (int)dwHeightTemp; i++)
				{
#ifdef USE_ASM
					CopyMemory16Bytes(pbDestTemp + dwOffset, pbSrcTemp - dwOffset, dwWidthTemp, 1, dwWidthTemp, dwWidthTemp);
#else
					CopyMemory_C(pbDestTemp + dwOffset, pbSrcTemp - dwOffset, dwWidthTemp, 1, dwWidthTemp, dwWidthTemp);
#endif
					if (dwWidthTemp % 16 != 0)
					{
#ifdef USE_ASM
						CopyMemory16Bytes(pbDestTemp + dwOffset + dwWidthTemp - 16, pbSrcTemp - dwOffset + dwWidthTemp - 16, 16, 1, dwWidthTemp, dwWidthTemp);
#else
						CopyMemory_C(pbDestTemp + dwOffset + dwWidthTemp - 16, pbSrcTemp - dwOffset + dwWidthTemp - 16, 16, 1, dwWidthTemp, dwWidthTemp);
#endif
					}
					dwOffset = dwOffset + dwWidthTemp;
				}
			}
			else
			{
				CopyVideoFrameEx(pbDestTemp, pbSrcTemp, dwWidthTemp, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbDestTemp + dwWidthTemp - 16, pbSrcTemp + dwWidthTemp - 16, 16, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
				}
			}
		}
		else
		{
			if (bNeedFlip)
			{
				DWORD dwOffset = 0;
				pbSrcTemp = pbSrc;
				pbDestTemp = pbDest;
				dwWidthTemp = dwFrameExtentTemp / dwHeight;
				dwHeightTemp = dwHeight;

				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);

				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
				}

				pbSrcTemp = pbSrcTemp + dwFrameExtentTemp - dwWidthTemp;

				for (i = 0; i < (int)dwHeightTemp; i++)
				{
#ifdef USE_ASM
					CopyMemory16Bytes(pbDestTemp + dwOffset, pbSrcTemp - dwOffset, dwWidthTemp, 1, dwWidthTemp, dwWidthTemp);
#else
					CopyMemory_C(pbDestTemp + dwOffset, pbSrcTemp - dwOffset, dwWidthTemp, 1, dwWidthTemp, dwWidthTemp);
#endif
					if (dwWidthTemp % 16 != 0)
					{
#ifdef USE_ASM
						CopyMemory16Bytes(pbDestTemp + dwOffset + dwWidthTemp - 16, pbSrcTemp - dwOffset + dwWidthTemp - 16, 16, 1, dwWidthTemp, dwWidthTemp);
#else
						CopyMemory_C(pbDestTemp + dwOffset + dwWidthTemp - 16, pbSrcTemp - dwOffset + dwWidthTemp - 16, 16, 1, dwWidthTemp, dwWidthTemp);
#endif
					}
					dwOffset = dwOffset + dwWidthTemp;
				}
			}
		}

		break;
	default:

		dwFrameExtentTemp = (dwFrameExtent / (dwWidth * dwHeight)) * (dwWidth * dwHeight);

		if (bInterlace && bNeedInterlace)
		{
			pbSrcTemp = pbSrc;
			pbDestTemp = pbDest;
			dwWidthTemp = dwFrameExtentTemp / dwHeight;
			dwHeightTemp = dwHeight;
			iStride = dwWidthTemp * 2;
			if (dwHeightTemp % 2 == 0)
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * dwHeightTemp / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, dwHeightTemp / 2, dwWidthTemp, iStride, 0);
				}
			}
			else
			{
				CopyVideoFrameEx(pbSrcTemp, pbDestTemp, dwWidthTemp, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
				CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2, pbDestTemp + dwWidthTemp, dwWidthTemp, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				if (dwWidthTemp % 16 != 0)
				{
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp - 16, pbDestTemp + dwWidthTemp - 16, 16, (dwHeightTemp + 1) / 2, dwWidthTemp, iStride, 0);
					CopyVideoFrameEx(pbSrcTemp + dwWidthTemp * (dwHeightTemp + 1) / 2 + dwWidthTemp - 16, pbDestTemp + dwWidthTemp + dwWidthTemp - 16, 16, (dwHeightTemp - 1) / 2, dwWidthTemp, iStride, 0);
				}
			}
			CopyVideoFrameEx(pbDestTemp, pbSrcTemp, dwWidthTemp, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			if (dwWidthTemp % 16 != 0)
			{
				CopyVideoFrameEx(pbDestTemp + dwWidthTemp - 16, pbSrcTemp + dwWidthTemp - 16, 16, dwHeightTemp, dwWidthTemp, dwWidthTemp, 0);
			}
		}

		break;
	}

	return AVER_TRUE;
}
