#!/bin/sh

BUILD_DIR=`pwd` > /dev/null
#BUILD_DIR=${BUILD_DIR%/*}
echo "$BUILD_DIR"

echo "Please Select Capture Card, Only support Ubuntu Platform!"
echo "1. cl311mn"
echo "2. cl311m2"
echo "3. cm311h"
echo "4. cn311h"
echo "5. cn312s"
echo "6. cn312m"

read BOARD
case $BOARD in
1)
	echo "Selected Capture Card cl311mn"
	BOARD=cl311mn
	BOARD_MARCO=AVER_CARD_CL311MN
;;
2)
	echo "Selected Capture Card cl311m2"
	BOARD=cl311m2
	BOARD_MARCO=AVER_CARD_CL311M2
;;
3)
	echo "Selected Capture Card cm311h"
	BOARD=cx311h
	BOARD_MARCO=AVER_CARD_CM311H
;;
4)
	echo "Selected Capture Card cn311h"
	BOARD=cx311h
	BOARD_MARCO=AVER_CARD_CM311H
;;
5)
	echo "Selected Capture Card cn312s"
	BOARD=cn312s
	BOARD_MARCO=AVER_CARD_CN312S
;;
6)
	echo "Selected Capture Card cn312m"
	BOARD=cn312m
	BOARD_MARCO=AVER_CARD_CN312M
;;
*)
	echo "Selected Nothing"
;;
esac

export BOARD
export BUILD_DIR
export BOARD_MARCO

make -C driver clean
make -C driver
cp driver/$BOARD.ko ./


