#ifndef BOARD_GPIO_H_
#define BOARD_GPIO_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { //defined by CL311M2 
        BOARD_GPIO_RESERVED=0,
        BOARD_GPIO_EDID_WP_D=1,
        BOARD_GPIO_HOT_PLUG=2,
        BOARD_GPIO_RESET_ADV7604=3,
        BOARD_GPIO_PWD_ADV7604=4,
        BOARD_GPIO_RESET_AIC3101=5,
        BOARD_GPIO_RESET_ADV7180=6,
        BOARD_GPIO_PWD_ADV7180=7,
        BOARD_GPIO_EDID_W1=8,
        BOARD_GPIO_EDID_W2=9, 
        BOARD_GPIO_LOCK_ADV7604=10,
        BOARD_GPIO_LOCK_ADV7180=11,	
        BOARD_GPIO_NUM, 
} board_gpio_e;

int board_gpio_init(cxt_mgr_handle_t cxt_mgr);
void board_set_gpio(cxt_mgr_handle_t cxt_mgr, board_gpio_e no, gpio_model_pin_value_t value);
gpio_model_pin_value_t board_get_gpio(cxt_mgr_handle_t cxt_mgr, board_gpio_e no);

#ifdef __cplusplus
}
#endif

#endif /* BOARD_GPIO_H_ */

