#ifndef BOARD_I2C_H_
#define BOARD_I2C_H_

#ifdef __cplusplus
extern "C" {
#endif

enum {
	I2C_BUS_COM_I2C0,
	//I2C_BUS_COM_I2C1, //last one defined for SDI interface
	//I2C_BUS_COM_I2C3,
	BOARD_I2C_BUS_NUM,
};

typedef struct {
	const char *name;
	unsigned short addr;
	void *context;
} i2c_dev_info_t;

const char *board_get_i2c_bus_name(int no);
int board_i2c_init(cxt_mgr_handle_t cxt_mgr, unsigned long dev_id);

#ifdef __cplusplus
}
#endif

#endif /* BOARD_I2C_H_ */

