#ifndef M24C02_H_
#define M24C02_H_

#ifdef __cplusplus
extern "C" {
#endif

#define M24C02_ID m24c02
#define M24C02_DRVNAME I2C_MODEL_MODULE_STR(m24c02)

typedef void (*wr_enable_func_t)(void *, BOOL_T);

typedef struct {
	wr_enable_func_t wr_enable_func;
} m24c02_cfg_t;

void m24c02_wr_edid(handle_t m24c02_handle, int start_block, int blocks, U8_T *edid);
void m24c02_rd_edid(handle_t m24c02_handle, int start_block, int blocks, U8_T *edid);

#ifdef __cplusplus
}
#endif

#endif /* M24C02_H_ */

