#!/bin/sh
#TARGET_KERNEL_VER=4.18.0-25-generic
#KERNEL_VER=`uname -r`
#if [ $KERNEL_VER!=$TARGET_KERNEL_VER ]
#then
#echo "current kernel version is not match $(TARGET_KERNEL_VER).
#echo "Please boot to correct kernel version then install again. Thanks"
#exit
#fi

echo "Please Select Capture Card, Only support Ubuntu Platform!"
echo "1. cl311mn"
echo "2. cl311m2"
echo "3. cm311h"
echo "4. cn311h"
echo "5. cn312s"
echo "6. cn312m"

read BOARD
case $BOARD in
1)
	echo "Selected Capture Card cl311mn"
	BOARD=cl311mn
;;
2)
	echo "Selected Capture Card cl311m2"
	BOARD=cl311m2
;;
3)
	echo "Selected Capture Card cm311h"
	BOARD=cx311h
;;
4)
	echo "Selected Capture Card cn311h"
	BOARD=cx311h
;;
5)
	echo "Selected Capture Card cn312s"
	BOARD=cn312s
;;
6)
	echo "Selected Capture Card cn312m"
	BOARD=cn312m
;;
*)
	echo "Selected Nothing"
;;
esac

MODULE_INSTALL_DIR=/lib/modules/`uname -r`/kernel/driver/media/avermedia
rm -f  $MODULE_INSTALL_DIR/$BOARD.ko
/sbin/depmod -a
